.386
.model flat,stdcall
option casemap:none

include ShineInHex.inc

.code

DllEntry proc public hIns:HINSTANCE, reason:DWORD, reserved1:DWORD

    push   hIns
    pop    hInstance
    .if reason==DLL_PROCESS_ATTACH
		invoke CreateClass
	.elseif reason==DLL_PROCESS_DETACH
		invoke UnregisterClass, ADDR classname, hInstance
	.endif
    mov    eax,TRUE
    ret

DllEntry Endp

CreateClass proc
	LOCAL  wc:WNDCLASSEX

	mov	   wc.cbSize,      SIZEOF WNDCLASSEX
	mov    wc.style,       CS_GLOBALCLASS+CS_SAVEBITS+CS_DBLCLKS
	mov	   wc.lpfnWndProc, OFFSET ShineInHexProc
	mov    wc.cbClsExtra,  0
	mov	   wc.cbWndExtra,  0
	push   hInstance
	pop	   wc.hInstance
	mov	   wc.hbrBackground, 0
	mov	   wc.lpszMenuName,  0
	mov	   wc.lpszClassName, OFFSET classname
	mov	   eax, 0
	mov	   wc.hIcon,   eax
	mov	   wc.hIconSm, eax
	invoke LoadCursor, 0, IDC_ARROW
	mov	   wc.hCursor, eax
	invoke RegisterClassEx, ADDR wc
	ret

CreateClass endp

ShineInHexProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL hexbuf[16]:BYTE
	LOCAL counter:DWORD
	LOCAL offs_t :DWORD
	LOCAL offs_l :DWORD
	LOCAL f_old  :DWORD
	LOCAL dc     :DWORD
	LOCAL ps   :PAINTSTRUCT
	LOCAL sinfo:SCROLLINFO
	LOCAL tm   :TEXTMETRIC
	LOCAL rc   :RECT
	LOCAL pt   :POINT

	mov		eax, uMsg
	.if eax==WM_CREATE
		mov    hex_dm.bk_color1,  0ff88ffh
		mov    hex_dm.bk_color2,  0cc88cch
		mov    hex_dm.bk_color3,  0aa88aah
		
		invoke CreateFontIndirect, ADDR lf
		mov    dword ptr [lf_choose+0], eax
		invoke CreateFontIndirect, ADDR lf2
		mov    dword ptr [lf_choose+4], eax
		invoke CreateFontIndirect, ADDR lf3
		mov    dword ptr [lf_choose+8], eax
		
		invoke CreatePopupMenu
		mov    hex_popup, eax
		mov    eax, offset hexlook
		mov    hex_dm.pointer, offset hexspace
		mov    hex_dm._size, 1
		mov    hex_dm.view_lenx, 8
		invoke AppendMenu, hex_popup, MF_STRING, 13000, ADDR menu_copy_text
		invoke AppendMenu, hex_popup, MF_STRING, 13001, ADDR menu_copy_hex
		invoke SendMessage, hWin, HEXM_SETFONT, 0, 0
		invoke SendMessage, hWin, HEXM_SETVIEW2SELCOL, 00c0ffc0h, 0
		invoke SendMessage, hWin, HEXM_SETVIEW3SELCOL, 00c0d4c0h, 0
		
	.elseif eax==HEXM_SETFONT
		mov    eax, wParam
		.if eax > 2
			xor    eax, eax
			ret
		.endif
		mov    eax, dword ptr [lf_choose+eax*4]
		mov    hex_dm.font, eax
		invoke GetDC, hWin
		mov    dc, eax
		invoke SelectObject,   dc, hex_dm.font
		invoke GetTextMetrics, dc, ADDR tm
		mov    eax, tm.tmAveCharWidth
		mov    hex_dm.fon_cx, eax
		shl    eax, 3
		mov    hex_dm.rc1.right, eax
		add    eax, 2
		mov    hex_dm.rc2.left, eax
		mov    eax, tm.tmHeight
		mov    hex_dm.fon_cy, eax
		;------
		mov    eax, hex_dm.fon_cx
		shl    eax, 1
		add    eax, hex_dm.fon_cx
		mov    ecx, hex_dm.view_lenx
		mul    ecx
		add    eax, hex_dm.rc2.left
		mov    hex_dm.rc2.right, eax
		add    eax, 2
		mov    hex_dm.rc3.left, eax
		;------
		mov    eax, hex_dm.fon_cx
		mov    ecx, hex_dm.view_lenx
		mul    ecx
		add    eax, hex_dm.rc3.left
		mov    hex_dm.rc3.right, eax
		invoke ReleaseDC,   hWin, dc
		invoke SendMessage, hWin, WM_SETFOCUS, 0, 0
		jmp    @resize
		
	.elseif eax==HEXM_SETVIEW1COL || eax==HEXM_SETVIEW2COL || eax==HEXM_SETVIEW3COL 
		mov    ecx, wParam
		mov    edx, lParam
		.if eax==HEXM_SETVIEW1COL
			mov    hex_dm.bk_color1,   ecx
			mov    hex_dm.text_color1, edx
		.elseif eax==HEXM_SETVIEW2COL
			mov    hex_dm.bk_color2,   ecx
			mov    hex_dm.text_color2, edx
		.elseif eax==HEXM_SETVIEW3COL
			mov    hex_dm.bk_color3,   ecx
			mov    hex_dm.text_color3, edx
		.endif
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==HEXM_SETVIEW2SELCOL || eax==HEXM_SETVIEW3SELCOL 
		mov    ecx, wParam
		.if eax==HEXM_SETVIEW2SELCOL
			mov    hex_dm.sel_color2, ecx
		.elseif eax==HEXM_SETVIEW3SELCOL
			mov    hex_dm.sel_color3, ecx
		.endif
		invoke InvalidateRect, hWin, 0, 0

	.elseif eax==HEXM_SETPOINTER
		mov    eax, wParam
		mov    ebx, lParam
		mov    hex_dm.pointer, eax
		mov    hex_dm._size, ebx
		invoke SendMessage, hWin, WM_SETFOCUS, 0, 0
		invoke SetCaretPos, hex_dm.rc2.left, 0
	@resize:
		mov    sinfo.cbSize, sizeof SCROLLINFO
		mov    sinfo.fMask, SIF_DISABLENOSCROLL+SIF_PAGE+SIF_RANGE
		mov    ecx, hex_dm.view_lenx
		mov    eax, hex_dm._size
		xor    edx, edx
		div    ecx
		mov    sinfo.nMax, eax
		xor    ecx, ecx
		mov    sinfo.nMin, ecx
		mov    eax, hex_dm.view_leny
		mov    sinfo.nPage, eax
		invoke SetScrollInfo, hWin, SB_VERT, ADDR sinfo, 1
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==HEXM_SETOFFSET
		mov    eax, wParam
		mov    hex_dm._start, eax
		invoke InvalidateRect, hWin, 0, 0
		
	.elseif eax==WM_CHAR
		mov    eax, wParam
		.if al >= 30h && al <= 39h || al >= 41h && al <= 46h || al >= 61h && al <= 66h
			mov    edi, hex_dm.pointer
			mov    ecx, hex_dm.sel_start
			mov    edx, hex_dm.sel_end
			.if ecx > edx
				add    edi, edx
				xchg   ecx, edx
				dec    edx
			.elseif ecx < edx
				add    edi, ecx
				dec    edx
			.else
				add    edi, ecx
			.endif
			xor    ebx, ebx
			.if al >= 30h && al <= 39h
				sub    al, 30h
			.elseif al >= 41h && al <= 46h
				sub    al, 37h
			.elseif al >= 61h && al <= 66h
				sub    al, 57h
			.endif
		@next_char:	
			mov    bl, byte ptr [edi]
			.if hex_dm.byte_nr==0
				and    bl, 00fh
				shl    al, 4
				.if edx==ecx
					inc    hex_dm.byte_nr
				.endif
			.elseif hex_dm.byte_nr==1
				and    bl, 0f0h
				or     bl, al
				mov    byte ptr [edi], bl				
				.if edx > ecx
					dec    edx
					inc    edi
					jmp    @next_char
				.endif
				invoke InvalidateRect, hWin, 0, 0
				mov    ecx, hex_dm.sel_start
				mov    edx, hex_dm.sel_end
				.if ecx==edx
					mov    wParam, VK_RIGHT
					jmp    @right
				.else
					mov    hex_dm.byte_nr, 0
					jmp    @selection
				.endif
			.endif
			or     bl, al
			mov    byte ptr [edi], bl
			.if edx > ecx
				dec    edx
				inc    edi
				shr    al, 4
				jmp    @next_char
			.endif
			invoke InvalidateRect, hWin, 0, 0
		.endif
	@selection:	
		
	.elseif eax==WM_KEYDOWN
	@right:
		invoke GetCaretPos, ADDR pt
		mov    eax, wParam
		.if eax==VK_RIGHT || eax==VK_LEFT
			mov    hex_dm.byte_nr, 0
			mov    edx, hex_dm.fon_cx
			lea    edx, [edx+edx*2]
			.if wParam==VK_RIGHT
				add    pt.x, edx
				mov    ecx, hex_dm.rc2.right
				mov    eax, hex_dm.view_leny
				mul    hex_dm.fon_cy
				sub    eax, hex_dm.fon_cy
				.if pt.x==ecx && pt.y!=eax
					mov    ecx, hex_dm.rc2.left
					mov    pt.x, ecx
					mov    ecx, hex_dm.fon_cy
					mov    eax, hex_dm.view_leny
					mul    hex_dm.fon_cy
					sub    eax, ecx 
					.if pt.y!=eax
						add    pt.y, ecx
					.endif
				.elseif pt.x==ecx
					mov    eax, hex_dm._size
					.if hex_dm.sel_end<eax
						invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
						mov    eax, hex_dm.rc2.left
						mov    pt.x, eax
					.else
						mov    eax, hex_dm.fon_cx
						lea    eax, [eax+eax*2]
						sub    pt.x, eax
						jmp    @skip
					.endif
				.endif
				inc    hex_dm.sel_start
				inc    hex_dm.sel_end
			.else
				mov    ecx, hex_dm.rc2.left
				.if pt.x==ecx && pt.y!=0
					mov    ecx, hex_dm.rc2.right
					mov    pt.x, ecx
					mov    ecx, hex_dm.fon_cy
					.if pt.y != 0
						sub    pt.y, ecx
					.endif
				.elseif pt.x==ecx
					mov    eax, 0
					.if hex_dm.sel_end>eax
						push   edx
						invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP, 0
						mov    eax, hex_dm.rc2.right
						mov    pt.x, eax
						pop    edx
					.else
						jmp    @skip
					.endif
				.endif
				dec    hex_dm.sel_start
				dec    hex_dm.sel_end
				sub    pt.x, edx
			.endif
		.elseif eax==VK_UP || eax==VK_DOWN
			.if eax==VK_UP
				mov    eax, hex_dm.view_lenx
				.if pt.y==0 && hex_dm.sel_end>eax
					invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP,   0
					jmp    @skip_a
				.elseif pt.y==0
					jmp    @skip
				.endif
				mov    ecx, hex_dm.fon_cy
				sub    pt.y, ecx
			@skip_a:
				mov    ecx, hex_dm.view_lenx
				sub    hex_dm.sel_start, ecx
				sub    hex_dm.sel_end,   ecx
			.else
				mov    eax, hex_dm.view_leny
				mul    hex_dm.fon_cy
				sub    eax, hex_dm.fon_cy
				mov    ecx, hex_dm._size
				sub    ecx, hex_dm.view_lenx
				.if pt.y==eax && hex_dm.sel_end<ecx
					invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
					jmp    @skip_b
				.elseif pt.y==eax
					jmp    @skip
				.endif
				mov    ecx, hex_dm.fon_cy
				add    pt.y, ecx
			@skip_b:	
				mov    ecx, hex_dm.view_lenx
				add    hex_dm.sel_start, ecx
				add    hex_dm.sel_end,   ecx
			.endif
		.endif
	@skip:
		invoke SetCaretPos, pt.x, pt.y
		
	.elseif eax==WM_SETFOCUS
		mov    ecx, hex_dm.fon_cx
		lea    ecx, [ecx*2]
		invoke CreateCaret, hWin, 0, ecx, hex_dm.fon_cy
		invoke ShowCaret,   hWin	
		invoke SetFocus,    hWin
		
	.elseif eax==WM_VSCROLL
		mov    sinfo.cbSize,  sizeof SCROLLINFO
		mov    sinfo.fMask,   SIF_ALL
		invoke GetScrollInfo, hWin, SB_VERT, ADDR sinfo
		push   sinfo.nPos
		mov    eax, wParam
		and    eax, 0ffffh
		cmp    eax, SB_TOP
		je     top
		cmp    eax, SB_BOTTOM
		je     bottom
		cmp    eax, SB_LINEUP
		je     lineup
		cmp    eax, SB_LINEDOWN
		je     linedown
		cmp    eax, SB_PAGEUP
		je     pageup
		cmp    eax, SB_PAGEDOWN
		je     pagedown
		cmp    eax, SB_THUMBTRACK
		je     ttrack
		cmp    eax, SB_THUMBPOSITION
		je     ttrack
		mov    eax, 0
		ret
top:
		mov    eax, sinfo.nMin
		mov    sinfo.nPos, eax
		jmp    @F
bottom:
		mov    eax, sinfo.nMax
		mov    sinfo.nPos, eax
		jmp    @F
lineup:
		dec    sinfo.nPos
		jmp    @F
linedown:
		inc    sinfo.nPos
		jmp    @F
pageup:
		mov    eax, sinfo.nPage
		sub    sinfo.nPos, eax
		jmp    @F
pagedown:
		mov    eax, sinfo.nPage
		add    sinfo.nPos, eax
		jmp    @F
ttrack:
		mov    eax, sinfo.nTrackPos
		mov    sinfo.nPos, eax
@@:
		.if SDWORD PTR sinfo.nPos < 0
			mov sinfo.nPos, 0
		.endif
		invoke GetCaretPos, ADDR pt
		mov    ecx, sinfo.nPos
		pop    eax
		sub    eax, ecx
		add    ecx, sinfo.nPage
		dec    ecx
		.if eax != 0 && ecx <= sinfo.nMax
			push   eax
			mul    hex_dm.fon_cy
			add    pt.y, eax
			invoke SetCaretPos, pt.x, pt.y
			mov    eax, sinfo.nPos
			mov    hex_dm.vscrollpos, eax
			invoke SetScrollInfo, hWin, SB_VERT, ADDR sinfo, TRUE
			invoke MemCopy, ADDR hex_dm.rc3, ADDR rc, sizeof RECT
			mov    rc.left, 0
			mov    eax, hex_dm.client_cy
			mov    rc.bottom, eax
			pop    eax
			mul    hex_dm.fon_cy
			mov    ecx, eax
			invoke ScrollWindowEx, hWin, 0, ecx, ADDR rc, ADDR rc, 0, 0, SW_INVALIDATE
		.endif
		
	.elseif eax==WM_LBUTTONDOWN || eax==WM_LBUTTONUP || eax==WM_MOUSEMOVE
		.if eax==WM_LBUTTONDOWN
			mov    hex_set2, 0
			invoke HideCaret, hWin
		.elseif eax==WM_LBUTTONUP
			invoke ShowCaret, hWin
		.endif
		mov    eax, lParam
		and    eax, 0ffffh
		.if eax >= hex_dm.rc2.left && hex_set2 == 0
			.if eax >= hex_dm.rc3.left
				sub    eax, hex_dm.rc3.left
				mov    ebx, hex_dm.fon_cx
				xor    edx, edx
				div    ebx
			.else
				sub    eax, hex_dm.rc2.left
				mov    ebx, hex_dm.fon_cx
				lea    ecx, [ebx+ebx*2]
				xor    edx, edx
				div    ecx
				shl    ebx, 1
			.endif
			.if edx > ebx
				inc eax
			.endif
			mov    edi, eax
			mov    eax, lParam
			shr    eax, 16
			mov    ecx, hex_dm.fon_cy
			xor    edx, edx
			div    ecx
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    edi, eax
			mov    eax, hex_dm.vscrollpos
			mul    hex_dm.view_lenx
			add    edi, eax
			.if uMsg==WM_LBUTTONDOWN
				mov    hex_set1, 1
				mov    hex_set2, 0
				mov    hex_dm.sel_start, edi
				mov    hex_dm.sel_end,   edi
			.elseif uMsg==WM_LBUTTONUP
				mov    hex_set2, 1
				mov    hex_dm.sel_end, edi
				invoke InvalidateRect, hWin, 0, 0
			.elseif uMsg==WM_MOUSEMOVE
				mov    eax, hex_dm.sel_end
				.if eax != edi
					mov    hex_dm.sel_end, edi
					invoke InvalidateRect, hWin, 0, 0
				.endif
			.endif
			mov    eax, lParam
			and    eax, 0ffffh
			sub    eax, hex_dm.rc2.left
			mov    ebx, hex_dm.fon_cx
			lea    ecx, [ebx+ebx*2]
			xor    edx, edx
			div    ecx
			shl    ebx, 1
			.if edx > ebx
				inc eax
			.endif
			mul ecx
			add eax, hex_dm.rc2.left
			.if eax < hex_dm.rc2.right
				mov    ecx, eax
				mov    eax, lParam
				shr    eax, 16
				xor    edx, edx
				div    hex_dm.fon_cy
				mul    hex_dm.fon_cy
				invoke SetCaretPos, ecx, eax
				mov    hex_dm.byte_nr, 0
			.endif
			
		.endif
		
	;.elseif eax==WM_TIMER
	;	.if hex_dm.timer_direction==1
	;		invoke SendMessage, hWin, WM_VSCROLL, SB_LINEUP, 0
	;	.else
	;		invoke SendMessage, hWin, WM_VSCROLL, SB_LINEDOWN, 0
	;	.endif
	
	.elseif eax==WM_RBUTTONUP
		mov    ecx, hex_dm.sel_start
		sub    ecx, hex_dm.sel_end
		.if ecx==0
			mov edi, MF_GRAYED
		.else
			mov edi, MF_ENABLED
		.endif
		invoke EnableMenuItem, hex_popup, 13000, edi
		invoke EnableMenuItem, hex_popup, 13001, edi
		invoke GetCursorPos, ADDR pt
		invoke TrackPopupMenuEx, hex_popup, TPM_LEFTALIGN, pt.x, pt.y, hWin, 0
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax==13000 || eax==13001
			mov    ebx, hex_dm.sel_start
			mov    ecx, hex_dm.sel_end
			.if ebx > ecx
				sub    ebx, ecx
				mov    ecx, ebx
			.else
				sub    ecx, ebx
			.endif
			shl    ecx, 1
			inc    ecx
			invoke GlobalAlloc, GMEM_MOVEABLE, ecx
			mov    hex_clip_copy, eax
			invoke GlobalLock, hex_clip_copy
			mov    hex_clip_point, eax
			cmp    eax, 0
			je     @exit
			mov    esi, hex_dm.pointer
			mov    edi, hex_clip_point
			mov    ecx, hex_dm.sel_start
			mov    edx, hex_dm.sel_end
			.if ecx > edx
				add    esi, edx
				sub    ecx, edx
			.else
				add    esi, ecx
				sub    edx, ecx
				mov    ecx, edx
			.endif
			.if wParam==13000
			@@:	
				cmp    ecx, 0
				jz     @F
				mov    al, byte ptr [esi]
				mov    byte ptr [edi], al
				inc    esi
				inc    edi
				dec    ecx
				jmp    @B
			@@:
			.else
				mov    ebx, offset hexlook
			@@:	
				xor    eax, eax
				cmp    ecx, 0
				jz     @F
				mov    al, byte ptr [esi]
				mov    dl, byte ptr [eax*4+ebx]
				mov    byte ptr [edi], dl
				inc    edi
				mov    dl, byte ptr [eax*4+ebx+1]
				mov    byte ptr [edi], dl
				inc    esi
				inc    edi
				dec    ecx
				jmp    @B
			@@:
			.endif
			mov    byte ptr [edi], 0
			invoke GlobalUnlock, hex_clip_copy
			invoke OpenClipboard, hWin
			invoke EmptyClipboard
			invoke SetClipboardData, CF_TEXT, hex_clip_copy
			invoke CloseClipboard
		@exit:
			invoke GlobalFree, hex_clip_copy
		.endif
		
	.elseif eax==WM_SIZE
		mov    eax, lParam
		and    eax, 0ffffh
		sub    eax, 8
		mov    ecx, hex_dm.fon_cx
		shl    ecx, 3
		sub    eax, ecx
		xor    edx, edx
		div    hex_dm.fon_cx
		shr    eax, 2
		.if hex_dm.view_lenx != eax && eax > 3
			mov    hex_dm.view_lenx, eax
			;------
			mov    eax, hex_dm.fon_cx
			lea    eax, [eax+eax*2]
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    eax, hex_dm.rc2.left
			mov    hex_dm.rc2.right, eax
			add    eax, 2
			mov    hex_dm.rc3.left, eax
			;------
			mov    eax, hex_dm.fon_cx
			mov    ecx, hex_dm.view_lenx
			mul    ecx
			add    eax, hex_dm.rc3.left
			mov    hex_dm.rc3.right, eax
			;------
			mov    eax, hex_dm.view_lenx
			mul    hex_dm.vscrollpos
			mov    ecx, hex_dm.sel_end
			sub    ecx, eax
			mov    eax, ecx
			xor    edx, edx
			div    hex_dm.view_lenx
			mov    ecx, eax
			mov    eax, edx    
			mov    edx, hex_dm.fon_cx
			lea    edx, [edx+edx*2]
			mul    edx
			add    eax, hex_dm.rc2.left
			mov    pt.x, eax
			mov    eax, ecx
			mul    hex_dm.fon_cy
			mov    pt.y, eax
			invoke SetCaretPos, pt.x, pt.y
			;------
			invoke InvalidateRect, hWin, 0, 0
		.endif
		mov    eax, lParam
		shr    eax, 16
		mov    ebx, eax
		xor    edx, edx
		div    hex_dm.fon_cy
		mov    ecx, eax
		mul    hex_dm.fon_cy
		.if ecx != hex_dm.view_leny
			mov    hex_dm.rc1.bottom, ebx
			mov    hex_dm.rc2.bottom, ebx
			mov    hex_dm.rc3.bottom, ebx
			mov    hex_dm.view_leny,  ecx
			mov    hex_dm.client_cy, eax
			invoke InvalidateRect, hWin, 0, 0
		.endif
		mov    sinfo.cbSize, sizeof SCROLLINFO
		mov    sinfo.fMask, SIF_DISABLENOSCROLL+SIF_PAGE+SIF_RANGE
		mov    eax, hex_dm.view_leny
		mov    sinfo.nPage, eax
		mov    ecx, hex_dm.view_lenx
		mov    eax, hex_dm._size
		xor    edx, edx
		div    ecx
		mov    sinfo.nMax, eax
		xor    ecx, ecx
		mov    sinfo.nMin, ecx
		invoke SetScrollInfo, hWin, SB_VERT, ADDR sinfo, 1
		invoke GetScrollPos, hWin, SB_VERT
		mov    hex_dm.vscrollpos, eax

	.elseif eax==WM_PAINT
		invoke BeginPaint, hWin, ADDR ps
		invoke SelectObject, ps.hdc, hex_dm.font
		mov    f_old, eax
		invoke MemCopy, ADDR ps.rcPaint, ADDR rc, sizeof RECT
		mov    eax, hex_dm.rc3.right
		mov    rc.left, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		mov    eax, hex_dm.rc1.right
		mov    rc.left, eax
		add    eax, 2
		mov    rc.right, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		mov    eax, hex_dm.rc2.right
		mov    rc.left, eax
		add    eax, 2
		mov    rc.right, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		invoke MemCopy, ADDR ps.rcPaint, ADDR rc, sizeof RECT
		mov    eax, hex_dm.view_leny
		mul    hex_dm.fon_cy
		mov    rc.top, eax
		invoke ExtTextOut, ps.hdc, 0, 0, ETO_OPAQUE, ADDR rc, 0, 0, 0
		;---STAGE_1---------------------------
		invoke SetBkColor,   ps.hdc, hex_dm.bk_color1
		invoke SetTextColor, ps.hdc, hex_dm.text_color1
		mov    edi, hex_dm.rc1.top
		mov    esi, hex_dm.vscrollpos
	@@:
		mov    eax, esi
		mul    hex_dm.view_lenx
		mov    ecx, eax
		add    ecx, hex_dm._start
		invoke dw2hex, ecx, ADDR hexbuf
		invoke ExtTextOut, ps.hdc, hex_dm.rc1.left, edi, 0, 0, ADDR hexbuf, 8, 0
		inc    esi
		add    edi, hex_dm.fon_cy
		mov    eax, hex_dm.rc1.bottom
		sub    eax, hex_dm.fon_cy
		cmp    edi, eax
		jb @B
		;---STAGE_2---------------------------
		invoke SetBkColor,   ps.hdc, hex_dm.bk_color2
		invoke SetTextColor, ps.hdc, hex_dm.text_color2
		mov    offs_t, 0
		mov    eax, hex_dm.rc2.left
		mov    offs_l, eax
		mov    esi, offset hexlook
		mov    edi, hex_dm.pointer
		mov    eax, hex_dm.vscrollpos
		mul    hex_dm.view_lenx
		add    edi, eax
		mov    ecx, hex_dm._size
		sub    ecx, eax
		mov    counter, ecx
	@@:	
		xor    ecx, ecx
		mov    cl, byte ptr [edi]
		shl    ecx, 2
		add    ecx, esi
		mov    eax, edi
		sub    eax, hex_dm.pointer
		push   ecx
		mov    ebx, hex_dm.sel_start
		mov    ecx, hex_dm.sel_end
		.if eax >= ebx && eax < ecx || eax >= ecx && eax < ebx
			invoke SetBkColor, ps.hdc, hex_dm.sel_color2
		.else
			invoke SetBkColor, ps.hdc, hex_dm.bk_color2
		.endif
		pop   ecx
		invoke ExtTextOut, ps.hdc, offs_l, offs_t, 0, 0, ecx, 3, 0
		inc    edi
		mov    eax, hex_dm.fon_cx
		lea    eax, [eax+eax*2]
		add    offs_l, eax
		mov    ecx, hex_dm.rc2.right
		sub    ecx, eax
		.if offs_l > ecx
			mov eax, hex_dm.rc2.left
			mov offs_l, eax
			mov eax, hex_dm.fon_cy
			add offs_t, eax
		.endif
		dec    counter
		.if counter==0
			invoke SetBkColor, ps.hdc, hex_dm.bk_color2
			mov    eax, hex_dm.rc2.right
			sub    eax, offs_l
			xor    edx, edx
			div    hex_dm.fon_cx
			invoke ExtTextOut, ps.hdc, offs_l, offs_t, 0, 0, ADDR hexspace, eax, 0
		@fill_empty2:
			mov    ecx, hex_dm.rc2.bottom
			sub    ecx, hex_dm.fon_cy
			mov    eax, hex_dm.fon_cy
			add    offs_t, eax
			cmp    offs_t, ecx
			jge    @full2
			mov    ecx, hex_dm.view_lenx
			lea    ecx, [ecx+ecx*2]
			invoke ExtTextOut, ps.hdc, hex_dm.rc2.left, offs_t, 0, 0, ADDR hexspace, ecx, 0
			jmp    @fill_empty2
		@full2:
		.else
			mov    eax, hex_dm.rc2.bottom
			sub    eax, hex_dm.fon_cy
			cmp    offs_t, eax
			jb @B
		.endif
		;---STAGE_3---------------------------
		invoke SetBkColor,   ps.hdc, hex_dm.bk_color3
		invoke SetTextColor, ps.hdc, hex_dm.text_color3
		mov    offs_t, 0
		mov    eax, hex_dm.rc3.left
		mov    offs_l, eax
		mov    edi, hex_dm.pointer
		mov    eax, hex_dm.vscrollpos
		mul    hex_dm.view_lenx
		add    edi, eax
		mov    esi, offset hex_byte
		mov    ecx, hex_dm._size
		sub    ecx, eax
		mov    counter, ecx
	@@:
		mov    cl, byte ptr [edi]
		.if cl < 33 || cl > 126
			mov    cl, '.'
		.endif
		mov    byte ptr [esi], cl
		mov    eax, edi
		sub    eax, hex_dm.pointer
		mov    ebx, hex_dm.sel_start
		mov    ecx, hex_dm.sel_end
		.if eax >= ebx && eax < ecx || eax >= ecx && eax < ebx
			invoke SetBkColor, ps.hdc, hex_dm.sel_color3
		.else
			invoke SetBkColor, ps.hdc, hex_dm.bk_color3
		.endif
		invoke ExtTextOut, ps.hdc, offs_l, offs_t, 0, 0, esi, 1, 0
		inc    edi
		mov    eax, hex_dm.fon_cx
		add    offs_l, eax
		mov    ecx, hex_dm.rc3.right
		sub    ecx, eax
		.if offs_l > ecx
			mov eax, hex_dm.rc3.left
			mov offs_l, eax
			mov eax, hex_dm.fon_cy
			add offs_t, eax
		.endif
		dec    counter
		mov    eax, counter
		.if eax==0
			invoke SetBkColor, ps.hdc, hex_dm.bk_color3
			xor    edx, edx
			mov    eax, hex_dm.rc3.right
			sub    eax, offs_l
			div    hex_dm.fon_cx
			invoke ExtTextOut, ps.hdc, offs_l, offs_t, 0, 0, ADDR hexspace, eax, 0
		@fill_empty3:
			mov    ecx, hex_dm.rc3.bottom
			sub    ecx, hex_dm.fon_cy
			mov    eax, hex_dm.fon_cy
			add    offs_t, eax
			cmp    offs_t, ecx
			jge    @full3
			invoke ExtTextOut, ps.hdc, hex_dm.rc3.left, offs_t, 0, 0, ADDR hexspace, hex_dm.view_lenx, 0
			jmp    @fill_empty3
		@full3:
		.else
			mov    eax, hex_dm.rc3.bottom
			sub    eax, hex_dm.fon_cy
			cmp    offs_t, eax
			jb @B
		.endif
		invoke SelectObject, ps.hdc, f_old
		invoke EndPaint, hWin, ADDR ps
		
	.elseif eax==WM_ERASEBKGND
		mov eax, 1
		ret
		
	.elseif eax==WM_DESTROY
		invoke DeleteObject, dword ptr [lf_choose+0]
		invoke DeleteObject, dword ptr [lf_choose+4]
		invoke DeleteObject, dword ptr [lf_choose+8]
		invoke DestroyMenu,  hex_popup
		
	.else
		invoke DefWindowProc, hWin, uMsg, wParam, lParam
		ret
	.endif
	
	xor eax, eax
	ret

ShineInHexProc endp

End DllEntry
